#include <stdio.h>

#define SIZE         101  /* Max aantal lanes&avenues plus 1
			     (tellen begint bij 1) */
#define QSIZE       3500  /* +/- SIZE^2/3 (bedenk zelf maar waarom /3) */
#define ONBEREIKBAAR  -2  /* willekeurig getal kleiner dan -1 */

typedef struct {
  int i,j;
  int afst;
} qelt;

int debug=0;

int n,m,maxstappen;
int bereik[SIZE][SIZE];
int gehad[SIZE][SIZE];

int qstart,qeind;
qelt q[QSIZE];

void Read() {
  int i,j;
  char c;
  scanf(" %d %d %d",&n,&m,&maxstappen);
  for (i=1;i<=n;i++) {
    for (j=1;j<=m;j++) {
      scanf(" %c",&c);
      bereik[i][j]=(c=='+'?-1:ONBEREIKBAAR);
    }
  }
}

void Push(int i,int j,int afst) {
  /* Hoop testen voor het pushen; niet mooi, maar wel overzichtelijker :*/
  if ((afst<=maxstappen)&&(bereik[i][j]!=ONBEREIKBAAR)) {
    if (gehad[i][j]==0) {
      gehad[i][j]=1;
      bereik[i][j]++;    /* Side-effect */
      q[qeind].i=i;
      q[qeind].j=j;
      q[qeind].afst=afst;
      qeind++;
      qeind%=QSIZE;
    }
  }
}

void Dijkstra() {
  qelt *qs;
  while ((qeind+QSIZE-qstart)%QSIZE>0) {
    qs=&(q[qstart]);
    /* Wandel langs avenue */
    if (qs->i%2==1) { /* Oneven avenue */
      if (qs->j>1) Push(qs->i,qs->j-1,qs->afst+1);
    } else { /* Even avenue */
      if (qs->j<m) Push(qs->i,qs->j+1,qs->afst+1);
    }
    /* Wandel langs lane */
    if (qs->j%2==1) {
      if (qs->i<n) Push(qs->i+1,qs->j,qs->afst+1);
    } else {
      if (qs->i>1) Push(qs->i-1,qs->j,qs->afst+1);
    }
    qstart++;
    qstart%=QSIZE;
  }
}

void Compute() {
  int i,j,a,b;
  /* Bereken alle \bar{b} */
  for (i=1;i<=n;i++) {
    for (j=1;j<=m;j++) {
      if (debug>=2) fprintf(stderr,"^");
      if (bereik[i][j]!=ONBEREIKBAAR) {
	/* Bereken alle kortste afstanden vanaf hier */
	for (a=1;a<=n;a++) {
	  for (b=1;b<=m;b++) {
	    gehad[a][b]=0;
	  }
	}
	qstart=0;
	qeind=0;
	Push(i,j,0);
	Dijkstra();
      }
    }
  }
}

void Print() {
  int i,j;
  int B=0;
  /* Bereken B */
  for (i=1;i<=n;i++) {
    for (j=1;j<=m;j++) {
      if (debug>=1) fprintf(stderr,"%4d",bereik[i][j]);
      if (bereik[i][j]>B) B=bereik[i][j];
    }
    if (debug>=1) fprintf(stderr,"\n");
  }
  if (debug>=1) fprintf(stderr,"B=%d\n",B);

  /* Nu kan er geprint worden */
  for (i=1;i<=n;i++) {
    for (j=1;j<=m;j++) {
      if (bereik[i][j]==ONBEREIKBAAR) printf("x");
      else if (bereik[i][j]==0) printf("Z");
      else if (3*bereik[i][j]<B) printf("R");
      else if (3*bereik[i][j]<2*B) printf("O"); 
      else printf("G");
    }
    printf("\n");
  }
}

int main() {
  int runs,r;
  scanf(" %d",&runs);
  for (r=0;r<runs;r++) {
    Read();
    Compute();
    Print();
    if (r!=runs-1) printf("\n");
  }
  return(0);
}
