/*
   RIEMANN

   (c) 07/08/'97 Meinte Boersma
   C-uitwerking van de NKP'97-opgave "Riemann"
*/

#include <stdio.h>
#include <math.h>

#define max 1000000

typedef int zeef[max+1];

void vul (zeef moebius)
{
  int i, som, veelvoud, kwadraat, wortel;

  som = 1;
  moebius[1] = 1;
  for (i=2; i<=max; i++)
    moebius[i] = 2;
  /* I and i = 1 */

  wortel = floor(sqrt(max));
  i = 2;

  while (2*i <= max) {
    /* vind het volgende priemgetal */
    while (moebius[i] != 2) {
      moebius[i] = (som += moebius[i]);
      i++;
    };

    /* i is priem ==> mu(i) = -1 */
    som--;
    moebius[i] = som;
    /* 1e zeefstap: veelvouden van de priem i "omklappen" */
    veelvoud = 2*i;
    while (veelvoud<=max) {
      if (moebius[veelvoud] == 2) {
	/* VEELVOUD nog niet aangeraakt */
	moebius[veelvoud] = -1;
      } else {
	/* "omklappen", want er komt een priem bij */
	moebius[veelvoud] = -moebius[veelvoud];
      };
      veelvoud += i;
    };
    /* 2e zeefstap: veelvouden van i^2 eruit zeven */
    if (i <= wortel) {
      kwadraat = i*i;
      veelvoud = kwadraat;
      while (veelvoud <= max) {
	moebius[veelvoud] = 0;
	veelvoud += kwadraat;
      };
    };

    /* I */
    i++;
  }

  /* rest van de zeef behandelen */
  for (; i<=max; i++) {
    if (moebius[i] == 2) {
      moebius[i] = --som;
    } else {
      moebius[i] = (som += moebius[i]);
    };
  };

  /* I and i = max ==> voor alle j: moebius[j] = mu(1) + ... + mu(j) */

}

int main (void)
{
  zeef moebius;
  int run, n, m;

  vul(moebius);
  scanf("%d", &m);
  for (run=0; run<m; run++) {
    scanf("%d", &n);
    printf("%d\n", abs(moebius[n]));
  }
  /* exit */
  return(0);
}
