program DNA (input, output);

{ (c)2 12/10/'97 by Meinte Boersma
}

const
   max = 50000;

type
   sequence = array[1..max] of char;
   prefix = array[1..max] of integer;

var
   m, i : integer;
   pi : prefix;
   TrexDNA : sequence;


{ subsequently all large data-structures are transferred
 as var-parameters to avoid copying and sizing out }


procedure computePrefixFunction (m : integer; var P : sequence; var pi : prefix);

var
   q, k : integer;

begin
   k := 0;
   pi[1] := 0;
   for q := 2 to m do begin
      while (k>0) and (P[k+1]<>P[q]) do begin
	 k := pi[k];
      end;
      if P[k+1]=P[q] then begin
	 k := k+1;
      end;
      pi[q] := k;
   end;
end; { computePrefixFunction }


function KMPoccurrences (n, m : integer; var P : sequence; var pi : prefix) : integer;

var
   matches,            { #matches }
   q, i : integer;     { iteration-variables}
   ch : char;

begin
   matches := 0;
   q := 0;
   for i := 1 to n do begin
      read(ch);   { ch = T[i] }
      while (q>0) and (P[q+1]<>ch) do begin
	 q := pi[q];
      end;
      if P[q+1]=ch then begin
	 q := q+1;
      end;
      if q=m then begin
	 matches := matches+1;
	 q := pi[q];
      end;
   end;
   KMPoccurrences := matches;
end; { KMPoccurrences }


procedure match (m : integer; var P : sequence; var pi : prefix);

var
   n, matches,
   nruns, run,
   maxmatches, optimum, length : integer;

begin
   { read #texts }
   readln(nruns);
   { read first text }
   readln(n);
   maxmatches := KMPoccurrences(n, m, P, pi);
   optimum := 1;
   length := n;
   { read next texts }
   for run := 2 to nruns do begin
      readln(n);
      matches := KMPoccurrences(n, m, P, pi);
      if (matches>maxmatches) or ((matches=maxmatches) and (n<length)) then begin
	 maxmatches := matches;
	 optimum := run;
	 length := n;
      end;
   end;
   writeln(optimum:1, ' ', maxmatches:1);
end; { match }



begin
   readln(m);
   for i := 1 to m do begin
      read(TrexDNA[i]);
   end;
   computePrefixFunction(m, TrexDNA, pi);
   match(m, TrexDNA, pi);
end.
